DAT programName byte "Led3BytePasm130109a0608b", 0
CON
{{
  ******* Public Notes *******
  
  This program assumes the LEDs are connections to the shift registers
  are grouped by color while the color information in the buffer alternates
  by colors.
   
}}
{
  ******* Private Notes *******
  120808a Change to use six shift registers. Controls 16 RGB LEDs.
  121104a Add ability to read in the pins.
  06b Abandon overall dimming ability.
  09a Remove ablitity to change resolution (for now).
  09a Hard code resolution and delays.
  121111c Kind of works but too much flicker.
  11e Changed columns variable which made for strange
  colors.
  11g Fixed and/add problem but still has problems.
  11j Working with 5-bit resolution each color.
  11k Try 6-bit each color. Works well.
  11l Try 7-bits. Works but noticable flicker.
  26a Start changing to read color information from an array
  of longs. Have each color use a separate shift register.
  26c Doesn't work. None of the LEDs lit up.
  Led3BytePasm121227a revert to LedShiftRegisters121111j.
  27c Seems to scroll text on one display okay.
  130109a Add more arrays to display.
  130109a0608a Clean up code. Code has been adapted to use with
  two daisy chainged RGB LED arrays.
  
  
} 
CON

  BIG_LOOP_OVERHEAD = 20
  SMALLER_LOOP_TIME = 48
  MAX_RESOLUTION = 256          ' since brightness is stored in a byte arrays
  PSEUDOREAL_SCALER = 1000
  MIN_PASM_WAITCNT = 10
  BITS_OF_RESOLUTION = 5
  RESOLUTON_REDUCER = 8 - BITS_OF_RESOLUTION
  ANODE_PINS = 8
  ARRAY_SIZE = 8 * 8 * 3 * 2 ' 384
  ' priorityFlag enumeration
  #0, RESOLUTION_PRIORITY, FREQUENCY_PRIORITY

  ' command enumeration, NO_CHANGE is also command to drive shift registers
  #0, NO_CHANGE, CHANGE_BUFFER_USED, CHANGE_BRIGHTNESS
  
VAR

  long cog
  long commandHub, clockPinTemp, latchPinTemp, dataPinTemp, bufferAddressHub
  long bufferSizeTemp
   
PUB Start(anodePin, clockPin, latchPin, dataPin, bufferPtr) | tempPeriod, tempPeriod1, tempRes, tempFreq, tempFreq1
'' bufferPtr is the address with byte array to be used to control the
'' brightness of the LED array. 

  clockPinTemp := clockPin
  latchPinTemp := latchPin
  dataPinTemp := dataPin
  bufferAddressHub := bufferPtr
  'bufferSizeTemp := bufferSize
  
  lastAnodeMask := 1 << (anodePin + ANODE_PINS - 1) 
  bufferAddressCog := bufferPtr 
  dataMask := 1 << dataPin
  latchMask := 1 << 15
  clockMask := 1 << 27
  resolutionCog := (1 << BITS_OF_RESOLUTION) - 1
 
  result := cog := cognew(@enter, @commandHub) + 1
 
  '**repeat until commandHub == NO_CHANGE  

PUB Stop
'' Stop driver and release cog

  if cog
    cogstop(cog~ - 1)

PUB NewBuffer(localPtr)
'' localPtr is the address with 120 bytes to be used to control the
'' brightness of the LED array.

  bufferAddressHub := localPtr
  commandHub := CHANGE_BUFFER_USED
  repeat until commandHub == NO_CHANGE

PUB GetProgramName

  result := @programName
             
DAT                     org
enter                   mov     temp1, par         ' copy hub address of parameters
                                                        ' commandHub
                        {add     temp1, #4               
                        rdlong  temp2, temp1            ' clockPinTemp
                        mov     clockMask, #1
                        shl     clockMask, temp2
                        add     temp1, #4
                        rdlong  temp2, temp1            ' latchPinTemp
                        mov     latchMask, #1
                        shl     latchMask, temp2
                        add     temp1, #4
                        rdlong  temp2, temp1            ' dataPinTemp  
                        mov     dataMask, #1
                        shl     dataMask, temp2
                        add     temp1, #4               ' location of bufferAddressHub
                        mov     bufferAddressPtr, temp1
                        add     temp1, #4
                        rdlong  arraySize, temp1        ' bufferSizeTemp      
                        add     temp1, #4
                        rdlong  resolutionCog, temp1    ' resolutionHub
                        add     temp1, #4
                        rdlong  loopDelayCog, temp1     ' addedWaitEachLoop
                     
                        'sub     resolutionCog, #1       ' since zero is included
                        
                        tjnz    loopDelayCog, #addDelayToLoop
                        mov     jumpDestination, #bigLoop     }
                        
setPins                 or      dira, clockMask
                        or      dira, latchMask 
                        or      dira, dataMask
                        mov     previousAnodeMask, lastAnodeMask
                        or      dira, previousAnodeMask
                        shr     previousAnodeMask, #1
                        or      dira, previousAnodeMask
                        shr     previousAnodeMask, #1
                        or      dira, previousAnodeMask
                        shr     previousAnodeMask, #1
                        or      dira, previousAnodeMask
                        shr     previousAnodeMask, #1
                        or      dira, previousAnodeMask
                        shr     previousAnodeMask, #1
                        or      dira, previousAnodeMask
                        shr     previousAnodeMask, #1
                        or      dira, previousAnodeMask
                        shr     previousAnodeMask, #1
                        or      dira, previousAnodeMask

                        'mov     previousAnodeMask, lastAnodeMask
                        'mov     temp1, rows
                        'sub     temp1, #1
                        'shl     previousAnodeMask, temp1
                        {**jmp     #changeBuffer
                                     
checkCommand            rdlong  cogCommand,par
                        wrlong  zero, par
                        add     cogCommand,#:jmpTable
                        jmp     cogCommand
:jmpTable               jmp     #newCycle   
                        jmp     #changeBuffer      
                       
'-------------------------------------------------------------------------------
}           
                        wrlong  zero, par    '** remove later
              
newCycle                mov     periodCount, resolutionCog   ' periodCount starts at 15 ends with 1
                        
{**delayedBigLoop          mov     offTime, cnt
                        add     offTime, loopDelayCog
                        waitcnt loopDelayCog, #0
}                                      
bigLoop                 mov     countdown, arraySize    ' 
                        mov     tempAddr, bufferAddressCog
                        'mov     tempAddr1, bufferAddressCog1
                        'mov     tempAddr2, bufferAddressCog2
                        
                        mov     columnCount, #0
                        mov     tempAnodeMask, lastAnodeMask
                                                        ' smallerLoop time start
smallerLoop             rdbyte  value, tempAddr
                       
                        shr     value, #RESOLUTON_REDUCER' reduce resolution to 5-bits
                                                        ' if value == 255 it will be changed to 15
                                                        ' if value == 0 it will stay 0
                        add     value, #1               ' if value == 15 it will be changed to 16
                                                        ' if value == 0 it will be changed to 1   
                        cmp     periodCount, value wc   ' if value == 16 it will greater than periodCount
                                                        ' 15 of 15 times (good)
                                                        ' if value == 1 it will greater than periodCount
                                                        ' 0 of 16 times (good)
                        ' if    periodCount < value then write c

                        muxc    outa, dataMask         
                        or      outa, clockMask

                        add     tempAddr, #3            ' jump to next memory with the same color

                   

                        add     columnCount, #1
                        
                        cmp     columnCount, columns0 wz
              if_z      sub     tempAddr, #23          ' jump back in memory to read next color (green) 
                        cmp     columnCount, columns1 wz
              if_z      sub     tempAddr, #23          ' jump back in memory to read next color (blue)  
                        cmp     columnCount, columns2 wz
              if_z      sub     tempAddr, #2           ' jump back small abount to next set of red data 
                        cmp     columnCount, columns3 wz
              if_z      sub     tempAddr, #23          ' jump back in memory to read second set of green data
                        cmp     columnCount, columns4 wz
              if_z      sub     tempAddr, #23          ' jump back in memory to read second set of blue data
                        cmp     columnCount, columns5 wz
                        andn    outa, clockMask

                        ' if    columnCount == columns then write z
              if_z      call     #advanceRow
                 
                        djnz    countdown, #smallerLoop 
              
                        
                        djnz    periodCount, #bigLoop '**jumpDestination
                        
                        jmp     #newCycle '**#checkCommand    

'-------------------------------------------------------------------------------

advanceRow              mov     columnCount, #0
                        sub     tempAddr, #2
                        or      outa, latchMask 
                        andn    outa, previousAnodeMask 
                        andn    outa, latchMask
                        or      outa, tempAnodeMask
                        mov     previousAnodeMask, tempAnodeMask 
                        shr     tempAnodeMask, #1
                        'add     rowCount, #1
                        'cmp     rowCount, rows wz
                                 
        'if_z            mov     rowCount, #0
        'if_z            mov     tempAnodeMask, lastAnodeMask
                        'or      outa, tempAnodeMask
                        'mov     previousAnodeMask, tempAnodeMask
                        
advanceRow_ret          ret            
                        

zero                    long 0
resolutionCog           long 0
dataMask                long 0
latchMask               long 0
clockMask               long 0
lastAnodeMask           long 0
tempAnodeMask           long 0
previousAnodeMask       long 0
bufferAddressCog        long 0
'bufferAddressCog1       long 0
'bufferAddressCog2       long 0
arraySize               long ARRAY_SIZE
'bufferAddressPtr        long 0
rows                    long 8
'rowCount                long 0
' ** This is just asking to wrapped up in a loop.
columns0                long 8  ' first set of red data done
columns1                long 16 ' first set of green data done
columns2                long 24 ' first set of blue data done
columns3                long 32 ' second set of red data done  
columns4                long 40 ' second set of green data done 
columns5                long 48 ' second set of blue data done 
value                   res 1
tempAddr                res 1
'tempAddr1               long 0
'tempAddr2               long 0
countdown               res 1
periodCount             res 1
'cogCommand              res 1
temp1                   res 1
'temp2                   res 1

'jumpDestination         long 0
offTime                 res 1

columnCount             res 1
                        fit

DAT ' License

{{

 ------------------------------------------------------------------------------------------------------------------------------
|                                                   TERMS OF USE: MIT License                                                  |                                                            
 ------------------------------------------------------------------------------------------------------------------------------
|Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    | 
|files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    |
|modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software|
|is furnished to do so, subject to the following conditions:                                                                   |
|                                                                                                                              |
|The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.|
|                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          |
|WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         |
|COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   |
|ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         |
 ------------------------------------------------------------------------------------------------------------------------------

}}